<id>
Avatars in Member List for YaBB 2.4
</id>

<version>
1.1
</version>

<mod info>
Description
-----------
This mod adds user avatars to the member list.

Installation
------------
1) Before installing, copy 'YaBB.js' from your public_html/yabbfiles directory into your cgi-bin/yabb2/ directory - Be sure to upload it back to your public_html/yabbfiles directory after.
2) Modify YaBB files using BoardMod or manually.
3) Upload modified files to your server in ASCII mode.
 
Files to edit
-------------
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Advanced.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/MemberList.lng
Sources/MemberList.pl
Sources/Subs.pl
YaBB.js

Mod History
-----------
1.0 - First Release - 17th June 2009
1.1 - Tidied up code and fixed empty table cell showing if disabled - 12th November 2009
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_avatarml = "Avatars in Member List|Derek Barnstorm|This mod adds user avatars to the member list.|1.1|12th November 2009";
	push (@installed_mods, "$mod_avatarml");
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
			$fix_avatar_img_size ||= 0;
</search for>

<add after>
			$fix_avatarml_img_size ||= 0; 
</add after>

<search for>
\$showuserpic = $showuserpic;				# Set to 1 to display each member's picture in the message view (by the ICQ.. etc.)
</search for>

<add after>
\$showuserpicml = $showuserpicml;			# Set to 1 to display each member's picture in the member list
</add after>

<search for>
\$fix_avatar_img_size = $fix_avatar_img_size;		# Set to 1 disable the image resize feature and sets the image size to the max_... values. If one of the max_... values is 0 the image is shown in his proportions to the other value. If both are 0 the image is shown at his original size.
</search for>

<add after>
\$max_avatarml_width = $max_avatarml_width;			# Set maximum pixel width to which the selfselected userpics in member list are resized, 0 disables this limit
\$max_avatarml_height = $max_avatarml_height;		# Set maximum pixel height to which the selfselected userpics in member list are resized, 0 disables this limit
\$fix_avatarml_img_size = $fix_avatarml_img_size;	# Set to 1 disable the image resize feature and sets the image size to the max_... values. If one of the max_... values is 0 the image is shown in his proportions to the other value. If both are 0 the image is shown at his original size. 
</add after>

<edit file>
Admin/Settings_Advanced.pl
</edit file>

<search for>
			name => 'fix_avatar_img_size',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => $admin_txt{'473a'},
			input_html => qq~<input type="text" name="max_avatarml_width" size="5" value="$max_avatarml_width" /> pixel~,
			name => 'max_avatarml_width',
			validate => 'number',
		},
		{
			description => $admin_txt{'473b'},
			input_html => qq~<input type="text" name="max_avatarml_height" size="5" value="$max_avatarml_height" /> pixel~,
			name => 'max_avatarml_height',
			validate => 'number',
		},
		{
			description => $admin_txt{'473c'},
			input_html => qq~<input type="checkbox" name="fix_avatarml_img_size" value="1"${ischecked($fix_avatarml_img_size)} />~,
			name => 'fix_avatarml_img_size',
			validate => 'boolean',
		},
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			name => 'showuserpic',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			description => $admin_txt{'384a'},
			input_html => qq~<input type="checkbox" name="showuserpicml" value="1"${ischecked($showuserpicml)} />~,
			name => 'showuserpicml',
			validate => 'boolean',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'384' => 'Show User Avatar in Message View?',
</search for>

<add after>
'384a' => 'Show User Avatar in Member List?',
</add after>

<search for>
'473x' => 'Disable the Image Resize feature for Avatars?<br /><span class="small">If checked, the image resize feature is disabled and the image size is set exactly to the values above. This <i>can</i> deform the images. If one of the above values is 0, the image is shown in his original proportions to the other value. If both are 0, the image is shown at his original size without any resizing.</span>',
</search for>

<add after>
'473a' => 'Avatar in Member List image display width (0 = no limit set)',
'473b' => 'Avatar in Member List image display height (0 = no limit set)',
'473c' => 'Disable the Image Resize feature for Avatars in Member List?<br /><span class="small">If checked, the image resize feature is disabled and the image size is set exactly to the values above. This <i>can</i> deform the images. If one of the above values is 0, the image is shown in his original proportions to the other value. If both are 0, the image is shown at his original size without any resizing.</span>',
</add after>

<edit file>
Languages/English/MemberList.lng
</edit file>

<search for>
'21' => 'Posts',
</search for>

<add after>
'34' => 'Avatar',
</add after>

<edit file>
Sources/MemberList.pl
</edit file>

<search for>
		$dr_regdate =~ s~(.*)(, 1?[0-9]):[0-9][0-9].*~$1~;
</search for>

<add after>
		
		if ($showuserpicml && $allowpics) {
            $userpic = qq~<td align="center" class="windowbg2"><a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="~ .(${$uid.$user}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$user}{'userpic'} : "$facesurl/${$uid.$user}{'userpic'}") . qq~" name="avatarml_img_resize" alt="" border="0" style="display:none" /></a></td>~;
        } else {
		    $userpic = '';
	    }
</add after>

<search for>
		<td class="windowbg">$link{$user}</td>
</search for>

<add before>
        $userpic
</add before>

<search for>
		    <noscript><input type="submit" /></noscript>
		   </form>
		);
</search for>

<add after>
		
        if ($showuserpicml && $allowpics) {
            $headertop = 8;
        } else {
            $headertop = 7;
        }
</add after>

<search for>
		$headercount = 7;
</search for>

<replace>
		$headercount = $headertop;
</replace>

<search for>
			$headercount += &ext_memberlist_get_headercount($additional_headers);
		}
</search for>

<add after>
		
		if ($showuserpicml && $allowpics) {
            $row_userpic = qq~<td class="catbg" align="center"><b>$ml_txt{'34'}</b></td>~;
        } else {
		    $row_userpic = '';
	    }
	    
</add after>

<search for>
				<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><a href="$scripturl?action=ml;sort=username"><b>$ml_txt{'35'}</b></a></td>
</search for>

<add before>
			    $row_userpic
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$output =~ s/"((avatar|post|attach|signat)_img_resize)"([^>]*>)/ &check_image_resize($1,$2,$3) /ge;
</search for>

<replace>
	$output =~ s/"((avatar|avatarml|post|attach|signat)_img_resize)"([^>]*>)/ &check_image_resize($1,$2,$3) /ge;
</replace>

<search for>
		if ($fix_avatar_img_size && $perl_do_it == 1 && $x[1] eq 'avatar') {
			if ($max_avatar_width  && $x[2] !~ / width=./)  { $x[2] =~ s/( style=.)/$1width:$max_avatar_width\px;/; }
			if ($max_avatar_height && $x[2] !~ / height=./) { $x[2] =~ s/( style=.)/$1height:$max_avatar_height\px;/; }
			$x[2] =~ s/display:none/display:inline/;
</search for>

<add after>
		} elsif ($fix_avatarml_img_size && $perl_do_it == 1 && $x[1] eq 'avatarml') {
			if ($max_avatarml_width  && $x[2] !~ / width=./)  { $x[2] =~ s/( style=.)/$1width:$max_avatarml_width\px;/; }
			if ($max_avatarml_height && $x[2] !~ / height=./) { $x[2] =~ s/( style=.)/$1height:$max_avatarml_height\px;/; }
			$x[2] =~ s/display:none/display:inline/;
</add after>

<search for>
	var avatar_img_w    = $max_avatar_width;
	var avatar_img_h    = $max_avatar_height;
	var fix_avatar_size = $fix_avatar_img_size;
</search for>

<add after>
	var avatarml_img_w    = $max_avatarml_width;
	var avatarml_img_h    = $max_avatarml_height;
	var fix_avatarml_size = $fix_avatarml_img_size;
</add after>

<edit file>
YaBB.js
</edit file>

<search for>
		if (type == 'avatar') {
			maxwidth  = avatar_img_w;
			maxheight = avatar_img_h;
</search for>

<add after>
		} else if (type == 'avatarml') {
			maxwidth  = avatarml_img_w;
			maxheight = avatarml_img_h;
</add after>

<search for>
		if ((fix_avatar_size && type == 'avatar') || (fix_post_size && type == 'post') || (fix_attach_size && type == 'attach') || (fix_signat_size && type == 'signat')) {
</search for>

<replace>
		if ((fix_avatar_size && type == 'avatar') || (fix_avatarml_size && type == 'avatarml') || (fix_post_size && type == 'post') || (fix_attach_size && type == 'attach') || (fix_signat_size && type == 'signat')) {
</replace>
